package  org.highangle.ui
{
	import flash.display.SpreadMethod;
	import flash.display.Sprite;
	import Date;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	
	/**
	 * ...
	 * @author kakyoin
	 * 
	 */
	public class Calendar extends Sprite 
	{
		private var d:Date = new Date();
		private var lavelYear:TextField = new TextField();
		private var lavelMonth:TextField = new TextField();
		private var dateList:Array = new Array();
		private var btnYearDown:Sprite = new Sprite();
		private var btnYearUp:Sprite = new Sprite();
		private var btnMonthDown:Sprite = new Sprite();
		private var btnMonthUp:Sprite = new Sprite();
		private var dateContainer:Sprite;
		private var txtSize:Number = 12;
		
		public function Calendar() 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			lavelYear.selectable = false;
			lavelYear.text = '0000';
			lavelYear.x = 20;
			addChild(lavelYear);
			
			lavelMonth.autoSize = TextFieldAutoSize.CENTER;
			lavelMonth.selectable = false;
			lavelMonth.text = '00';
			lavelMonth.x = 110;
			addChild(lavelMonth);
			
			
			
			drawTriangle(btnMonthDown);
			drawTriangle(btnMonthUp,'right');
			drawTriangle(btnYearDown);
			drawTriangle(btnYearUp,'right');
			
			btnYearDown.x = lavelYear.x - txtSize;
			btnYearDown.y = lavelYear.y +  txtSize * 0.2;
			btnYearUp.x = lavelYear.x + lavelYear.textWidth + txtSize * 0.3;
			btnYearUp.y = lavelYear.y +  txtSize * 0.2;
			
			btnMonthDown.x = lavelMonth.x - txtSize;
			btnMonthDown.y = lavelMonth.y +  txtSize * 0.2;
			btnMonthUp.x = lavelMonth.x + lavelMonth.textWidth + txtSize * 0.3;
			btnMonthUp.y = lavelMonth.y +  txtSize * 0.2;
			
			createDateContainer();
			refresh();
			
			var ar:Array = [btnMonthDown, btnMonthUp, btnYearDown, btnYearUp];
			for (var i:Number = 0; i < ar.length; i++ )
			{
				ar[i].addEventListener(MouseEvent.CLICK, onClickUpDown);
				addChild(ar[i]);
			}
		}
		
		private function refresh():void
		{
			lavelYear.text = d.getFullYear().toString();
			lavelMonth.text = Number(d.getMonth() + 1).toString();
			
			refreshDateContainer();
		}
		
		private function onClickUpDown(e:Event):void
		{
			switch (e.target)
			{
				case btnYearDown:
					d.setFullYear(d.getFullYear() - 1);
					break;
					
				case btnYearUp:
					d.setFullYear(d.getFullYear() + 1);
					break;
					
				case btnMonthDown:
					d.setMonth( (d.getMonth() > 0)? d.getMonth()-1 : 11 );
					break;
					
				case btnMonthUp:
					d.setMonth( (d.getMonth() < 11)? d.getMonth()+1 : 0 );
					break;
			}
			
			refresh();
			var e2:Event = new Event(Event.CHANGE);
			dispatchEvent(e2);
			e2 = null;
		}
		
		private function drawTriangle(tr:Sprite, vector:String = 'left'):void
		{
			tr.graphics.beginFill(0x000000,1);
			switch (vector)
			{
				case 'left':
					tr.graphics.drawTriangles(Vector.<Number>([0, txtSize*0.5, txtSize, 0, txtSize, txtSize]));
					break;
					
				case 'right':
					tr.graphics.drawTriangles(Vector.<Number>([txtSize, txtSize*0.5, 0, 0, 0, txtSize]));
					break;
			}
			
			tr.graphics.endFill();
		}
		
		private function createDateContainer():void
		{
			var i:Number;
			var dateContainer_y:Number = 20;
			
			dateContainer = new Sprite();
			addChild(dateContainer);
			dateContainer.y = dateContainer_y;
			dateList = new Array();
			
			for (i= 0; i < 31; i++)
			{
				dateList.push(new TextField());
				dateContainer.addChild(dateList[i]);
				dateList[i].visible = false;
			}
		}
		
		private function refreshDateContainer():void
		{
			var d2:Date = new Date(d);
			var targetDate:Number = 1;
			var padingX:Number = txtSize * 1.7;
			var padingY:Number =  txtSize * 1.3;
			var posY:Number = 0;
			var i:Number;
			
			for (i= 0; i < dateList.length; i++)
			{
				dateList[i].visible = false;
				
			}
			
			d2.setDate(1);
			var tf:TextFormat = new TextFormat();
			tf.align = 'right';
			tf.size = txtSize;
			do { 
				
				var target:TextField = dateList[targetDate-1];
				target.visible = true;
				target.autoSize = TextFieldAutoSize.RIGHT;
				target.selectable = false;
				target.text = targetDate.toString();
				target.x = d2.getDay()*padingX
				target.y = posY;
				posY = (d2.getDay() == 6)? posY + padingY : posY;
				switch (d2.getDay())
				{
					case 0:
						tf.color = 0xff0000;
						break;
					case 6:
						tf.color = 0x0000ff;
						break;	
						
					default : tf.color = 0x00000;
				}
				
				target.setTextFormat(tf);
				target.addEventListener(MouseEvent.CLICK, onClickDate);
				targetDate++;
				d2.setDate(targetDate);
			}while (d2.getDate() > 1)
		}
		
		private function onClickDate(e:MouseEvent):void
		{
			d.date = e.target.text;
			var e2:Event = new Event(Event.SELECT);
			dispatchEvent(e2);
			e2 = null;
		}
		
		public function get date():Date
		{
			return d;
		}
	}

}